package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLScheduleBandNode_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLScheduleBandNode extends ISLScheduleNode  {
	
	/* @generated */
	protected ISLScheduleBandNode(long ptr) {
		/*** PROTECTED REGION ID(ISLScheduleBandNode_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLScheduleBandNode build(long ptr) {
		return new ISLScheduleBandNode(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLScheduleBandNode_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_schedule_node_band_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_schedule_node_band_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_schedule_node_band_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_get_partial_schedule 
	 * 
	 * @generated
	**/
	public ISLMultiUnionPWAff getPartialSchedule() {
		/*** PROTECTED REGION ID(isl_schedule_node_band_get_partial_schedule) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_schedule_node_band_get_partial_schedule(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_get_partial_schedule_union_map 
	 * 
	 * @generated
	**/
	public ISLUnionMap getPartialScheduleUnionMap() {
		/*** PROTECTED REGION ID(isl_schedule_node_band_get_partial_schedule_union_map) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionMap.build(ISLNative.isl_schedule_node_band_get_partial_schedule_union_map(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_n_member 
	 * 
	 * @generated
	**/
	public int getNbMembers() {
		/*** PROTECTED REGION ID(isl_schedule_node_band_n_member) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_schedule_node_band_n_member(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_member_get_coincident 
	 * 
	 * @generated
	**/
	public boolean getCoincident(int pos) {
		/*** PROTECTED REGION ID(isl_schedule_node_band_member_get_coincident) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_schedule_node_band_member_get_coincident(getNativePtr(this), pos) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_member_set_coincident 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLScheduleBandNode setCoincident(int pos, int coincident) {
		/*** PROTECTED REGION ID(isl_schedule_node_band_member_set_coincident) DISABLED START ***/
		ISLScheduleBandNode res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = (ISLScheduleBandNode)ISLScheduleBandNode.build(ISLNative.isl_schedule_node_band_member_set_coincident(getNativePtr(this), pos, coincident));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_get_permutable 
	 * 
	 * @generated
	**/
	public boolean getPermutable() {
		/*** PROTECTED REGION ID(isl_schedule_node_band_get_permutable) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_schedule_node_band_get_permutable(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_set_permutable 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLScheduleBandNode setPermutable(int permutable) {
		/*** PROTECTED REGION ID(isl_schedule_node_band_set_permutable) DISABLED START ***/
		ISLScheduleBandNode res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = (ISLScheduleBandNode)ISLScheduleBandNode.build(ISLNative.isl_schedule_node_band_set_permutable(getNativePtr(this), permutable));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_member_get_ast_loop_type 
	 * 
	 * @generated
	**/
	public ISLASTLoopType getASTLoopType(int pos) {
		/*** PROTECTED REGION ID(isl_schedule_node_band_member_get_ast_loop_type) DISABLED START ***/
		ISLASTLoopType res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTLoopType.build(ISLNative.isl_schedule_node_band_member_get_ast_loop_type(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_member_set_ast_loop_type 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLScheduleBandNode setASTLoopType(int pos, ISLASTLoopType type) {
		/*** PROTECTED REGION ID(isl_schedule_node_band_member_set_ast_loop_type) DISABLED START ***/
		ISLScheduleBandNode res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = (ISLScheduleBandNode)ISLScheduleBandNode.build(ISLNative.isl_schedule_node_band_member_set_ast_loop_type(getNativePtr(this), pos, type.getValue()));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_member_get_isolate_ast_loop_type 
	 * 
	 * @generated
	**/
	public ISLASTLoopType getIsolateASTLoopType(int pos) {
		/*** PROTECTED REGION ID(isl_schedule_node_band_member_get_isolate_ast_loop_type) DISABLED START ***/
		ISLASTLoopType res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTLoopType.build(ISLNative.isl_schedule_node_band_member_get_isolate_ast_loop_type(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_member_set_isolate_ast_loop_type 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLScheduleBandNode setIsolateASTLoopType(int pos, ISLASTLoopType type) {
		/*** PROTECTED REGION ID(isl_schedule_node_band_member_set_isolate_ast_loop_type) DISABLED START ***/
		ISLScheduleBandNode res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = (ISLScheduleBandNode)ISLScheduleBandNode.build(ISLNative.isl_schedule_node_band_member_set_isolate_ast_loop_type(getNativePtr(this), pos, type.getValue()));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_get_ast_build_options 
	 * 
	 * @generated
	**/
	public ISLUnionSet getASTBuildOptions() {
		/*** PROTECTED REGION ID(isl_schedule_node_band_get_ast_build_options) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionSet.build(ISLNative.isl_schedule_node_band_get_ast_build_options(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_set_ast_build_options 
	 * 
	 * @take this options
	 * @generated
	**/
	public ISLScheduleBandNode setASTBuildOptions(ISLUnionSet options) {
		/*** PROTECTED REGION ID(isl_schedule_node_band_set_ast_build_options) DISABLED START ***/
		ISLScheduleBandNode res;
		
		synchronized(LOCK) {
			checkParameters(this, options);
			try {
				res = (ISLScheduleBandNode)ISLScheduleBandNode.build(ISLNative.isl_schedule_node_band_set_ast_build_options(getNativePtr(this), getNativePtr(options)));
			} finally {
				taken(this);
				taken(options);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_get_ast_isolate_option 
	 * 
	 * @generated
	**/
	public ISLSet getASTIsolateOption() {
		/*** PROTECTED REGION ID(isl_schedule_node_band_get_ast_isolate_option) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSet.build(ISLNative.isl_schedule_node_band_get_ast_isolate_option(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_scale 
	 * 
	 * @take this mv
	 * @generated
	**/
	public ISLScheduleBandNode scale(ISLMultiVal mv) {
		/*** PROTECTED REGION ID(isl_schedule_node_band_scale) DISABLED START ***/
		ISLScheduleBandNode res;
		
		synchronized(LOCK) {
			checkParameters(this, mv);
			try {
				res = (ISLScheduleBandNode)ISLScheduleBandNode.build(ISLNative.isl_schedule_node_band_scale(getNativePtr(this), getNativePtr(mv)));
			} finally {
				taken(this);
				taken(mv);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_scale_down 
	 * 
	 * @take this mv
	 * @generated
	**/
	public ISLScheduleBandNode scaleDown(ISLMultiVal mv) {
		/*** PROTECTED REGION ID(isl_schedule_node_band_scale_down) DISABLED START ***/
		ISLScheduleBandNode res;
		
		synchronized(LOCK) {
			checkParameters(this, mv);
			try {
				res = (ISLScheduleBandNode)ISLScheduleBandNode.build(ISLNative.isl_schedule_node_band_scale_down(getNativePtr(this), getNativePtr(mv)));
			} finally {
				taken(this);
				taken(mv);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_mod 
	 * 
	 * @take this mv
	 * @generated
	**/
	public ISLScheduleBandNode mod(ISLMultiVal mv) {
		/*** PROTECTED REGION ID(isl_schedule_node_band_mod) DISABLED START ***/
		ISLScheduleBandNode res;
		
		synchronized(LOCK) {
			checkParameters(this, mv);
			try {
				res = (ISLScheduleBandNode)ISLScheduleBandNode.build(ISLNative.isl_schedule_node_band_mod(getNativePtr(this), getNativePtr(mv)));
			} finally {
				taken(this);
				taken(mv);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_shift 
	 * 
	 * @take this shift
	 * @generated
	**/
	public ISLScheduleBandNode shift(ISLMultiUnionPWAff shift) {
		/*** PROTECTED REGION ID(isl_schedule_node_band_shift) DISABLED START ***/
		ISLScheduleBandNode res;
		
		synchronized(LOCK) {
			checkParameters(this, shift);
			try {
				res = (ISLScheduleBandNode)ISLScheduleBandNode.build(ISLNative.isl_schedule_node_band_shift(getNativePtr(this), getNativePtr(shift)));
			} finally {
				taken(this);
				taken(shift);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_tile 
	 * 
	 * @take this sizes
	 * @generated
	**/
	public ISLScheduleBandNode tile(ISLMultiVal sizes) {
		/*** PROTECTED REGION ID(isl_schedule_node_band_tile) DISABLED START ***/
		ISLScheduleBandNode res;
		
		synchronized(LOCK) {
			checkParameters(this, sizes);
			try {
				res = (ISLScheduleBandNode)ISLScheduleBandNode.build(ISLNative.isl_schedule_node_band_tile(getNativePtr(this), getNativePtr(sizes)));
			} finally {
				taken(this);
				taken(sizes);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_split 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLScheduleBandNode split(int pos) {
		/*** PROTECTED REGION ID(isl_schedule_node_band_split) DISABLED START ***/
		ISLScheduleBandNode res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = (ISLScheduleBandNode)ISLScheduleBandNode.build(ISLNative.isl_schedule_node_band_split(getNativePtr(this), pos));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_band_sink 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLScheduleBandNode sink() {
		/*** PROTECTED REGION ID(isl_schedule_node_band_sink) DISABLED START ***/
		ISLScheduleBandNode res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = (ISLScheduleBandNode)ISLScheduleBandNode.build(ISLNative.isl_schedule_node_band_sink(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public void accept(IISLScheduleNodeVisitor visitor) {
		visitor.visitISLScheduleBandNode(this);
	}
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLScheduleBandNode_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
